﻿package {
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	
	public class Avatar extends MovieClip {
		
		var movingLeft:Boolean;
		var movingRight:Boolean;
		var movingUp:Boolean;
		var movingDown:Boolean;
		var speed:int;
		var gotThePie:Boolean;
		
		public function Avatar() {
			addEventListener(Event.ENTER_FRAME, moveMyGuy);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, startMovement);
			stage.addEventListener(KeyboardEvent.KEY_UP, stopMovement);
			stage.addEventListener(Event.ENTER_FRAME, pieChecker);
			stage.addEventListener(Event.ENTER_FRAME, orcChecker);
			movingLeft = false;
			movingRight = false;
			movingUp = false;
			movingDown = false;
			speed = 8;
			gotThePie = false;
		}
		
		public function startMovement(e:KeyboardEvent) {
			if (e.keyCode == 39) {
				movingRight = true;
			}
			if (e.keyCode == 37) {
				movingLeft = true;
			}
			if (e.keyCode == 38) {
				movingUp = true;
			}
			if (e.keyCode == 40) {
				movingDown = true;
			}
		}
		
		public function stopMovement(e:KeyboardEvent) {
			if (e.keyCode == 39) {
				movingRight = false;
			}
			if (e.keyCode == 37) {
				movingLeft = false;
			}
			if (e.keyCode == 38) {
				movingUp = false;
			}
			if (e.keyCode == 40) {
				movingDown = false;
			}
		}
		
		public function moveMyGuy(e:Event) {
			if (movingRight) {
				x+=speed;
				if (gotThePie) MovieClip(root).pie.x += speed;
			}
			if (movingLeft) {
				x-=speed;
				if (gotThePie) MovieClip(root).pie.x -= speed;
			}
			if (movingUp) {
				if (gotThePie) MovieClip(root).pie.y -= speed; 
				y-=speed;
			}
			if (movingDown) {
				y+=speed;
				if (gotThePie) MovieClip(root).pie.y += speed;
			}
		}
		
		public function pieChecker(e:Event) {
			if (!gotThePie) {
				if (hitTestObject(MovieClip(root).pie)) {
					MovieClip(root).pieMessage.text = "Sweet!";
					gotThePie = true;
				}
			} 
		}
		public function orcChecker(e:Event) {
			if (hitTestObject(MovieClip(root).orc)) {
				die();
			}
		}
		
		public function die() {
			removeEventListener(Event.ENTER_FRAME, moveMyGuy);
			visible = false;
			MovieClip(root).pieMessage.text = "Oh noes!";
		}
	}
}